/* main 20240713 , rev20240817 */
/* main active */
/* edmi - text editor min - */
/* (c)2024 wnc develop / t.w. */
/* The MIT License */

/* debug code */
#if 0
void debug2out(int a)
{
	ESC_csave();cursor(70,22);printf("%d",a);fflush(stdout);ESC_cload();
	getch();
}
#endif

/*================*/
/* main mojisyori */
/*================*/
/* sx screen cursor x */
/* sy screen cursor y */
/* bsx backup sx */
/* bsy backup sy */
/* mypos memory position y */
/* mxypos memory position x(+y) */
/* oypos memory position ,screen draw origin */
/* tmem textmemory addr */
/* tsize textmemory size(MAX) */
/* tlinecnt text total line count */
/* scexec screen draw execute */

int mojisyori(edit_dat *wed,char a)
{
	char w1char;
	int w2int,w3pos,w4mxypos,w5sx;
	int c,ret,i,f1;
	static int f_sjis1b;  /* shift jis moji 1 banme */
	int retmojisyori;

	edit_dat tmped;
	tmped.tmem = wed->tmem;
	tmped.tsize = wed->tsize;
	tmped.oypos = wed->oypos;
	tmped.mypos = wed->mypos;
	tmped.mxypos = wed->mxypos;
	tmped.tab = wed->tab;
	tmped.tusize = wed->tusize;  /* ed10 */
	wed->scexec = SC_ALL;

	retmojisyori = 0;  /* no error return */

	switch(a)
	{
		case EDSCUP: /* up key */
			wed->scexec = SC_SONOMAMA; /* kakikaenai cursor nomi */
			w2int = zengyoypos(wed);
			wed->mypos = w2int;
			wed->mxypos = wed->mypos;

			adjtabmxypos(wed);  /* sx -> mxypos adjust */
			adjtabscx(wed);  /* mxypos -> sx adjust */
			w5sx=wed->sx;
			w2int = chksjismx(wed);

			if( w2int == 0)
			{
				/* no error */
			}
			else
			{
				if(wed->mxypos >= 1)
				{
					wed->mxypos--;
					w5sx = gettabscx(wed);
				}
			}

			if(w5sx > SCRMJIMAXm1)
			{
				w5sx = SCRMJIMAXm1;
			}
			wed->sx = w5sx;

			if(wed->sy >= 1)
			{
				wed->sy--;
			}
			else
			{
				if(wed->oypos > wed->mypos)
				{
					wed->oypos = wed->mypos;
					wed->scexec = SC_SENTOADD; /* screen sentou kakikae */
				}
			}
			break;

		case EDSCDOWN: /* down key */
			wed->scexec = SC_SONOMAMA; /* kakikaenai cursor nomi */
			w2int = zigyoypos(&tmped);
			if(w2int <= wed->mypos) { break; }
			wed->mypos = w2int;
			wed->mxypos = wed->mypos;
			adjtabmxypos(wed);  /* sx -> mxypos adj */
			adjtabscx(wed);    /* mxypos -> sx adj */
			w5sx = wed->sx;

			w2int = chksjismx(wed);

			if( w2int == 0)
			{
				/* no error */
			}
			else
			{
				if(wed->mxypos >= 1)
				{
					wed->mxypos--;
					w5sx = gettabscx(wed);
				}
			}

			if(w5sx > SCRMJIMAXm1)
			{
				w5sx = SCRMJIMAXm1;
			}
			wed->sx = w5sx;

			if((wed->sy) < SCRGYOMAXm1)
			{
				wed->sy++;
			}
			else
			{
				tmped.mypos = wed->oypos;
				w2int = zigyoypos(&tmped);
				if(w2int > wed->oypos)
				{
					wed->oypos = w2int;
					wed->scexec = SC_SAIGOADD; /* saisyu gyo add */
				}
				else
				{
					/* */
				}
			}
			break;

		case EDSCLEFT: /* left key */
			wed->scexec = SC_SONOMAMA;
			if(wed->mxypos >= 1)
			{
				wed->mxypos--;
				/* shift jis chk */
				if(chksjismx(wed) == 0)
				{
					/* none (shift jis tochu de nai) */
				}
				else
				{
					/* shift jis tocyu */
					if(wed->mxypos >= 1)
					{
						wed->mxypos--;
					}
				}

				wed->sx = gettabscx(wed);
				if(wed->sx > SCRMJIMAXm1)
				{
					wed->sx = SCRMJIMAXm1;
				}
			}
			else  /* mxypos <= 0 */
			{
				/* none */
			}

			/* mae no gyo ? */
			if(wed->mxypos < wed->mypos)
			{
				/* mae no gyou */
				wed->mypos = zengyoypos(wed);
				wed->mxypos = wed->mypos;
				w2int = wed->mypos;

				wed->sx = SCRMJIMAXm1;
				adjtabmxypos(wed);  /* sx -> mxypos adj */
				adjtabscx(wed);     /* mxypos -> sx adj */

				w2int = chksjismx(wed);
				if( w2int == 0)
				{
					/* no error */
				}
				else
				{
					/* shift jis */
					if(wed->mxypos >= 1)
					{
						wed->mxypos--;
						wed->sx--;
					}
				}

				if(wed->sy >= 1)
				{
					wed->sy--;
				}
				else
				{
					if(wed->oypos > wed->mypos)
					{
						wed->oypos = wed->mypos;
						wed->scexec = SC_SENTOADD; /* scr sentou gyo */
					}
				}
			}
			break;

		case EDSCRIGHT: /* right key */
			wed->scexec = SC_SONOMAMA; /* kakikae nai */
			f1=0;
			w1char = wed->tmem[(wed->mxypos)];
			if(w1char == EOF_CODE) { break;} /* ed10 */
			w4mxypos = wed->mxypos; /* backup */

			tmped.sx = wed->sx;
			w5sx = gettabscx(&tmped);

			/* shift jis chk */
			if( chksjis1b( wed->tmem[(wed->mxypos)]) != 0)
			{	/* shift jis */
				wed->mxypos++;
			}
			wed->mxypos++;

			wed->sx = gettabscx(wed);
			if(wed->sx > SCRMJIMAXm1)
			{
				wed->sx = SCRMJIMAX;
			}

			if(w1char == TAB_CODE)
			{
				if(wed->sx > SCRMJIMAXm1)
				{
					wed->sx = SCRMJIMAXm1;
				}
			}

			if(w5sx > SCRMJIMAX) { f1=1;}

			if((wed->sx >= SCRMJIMAX)||(w1char == CR_CODE)||(f1==1))
			{
				w3pos = zigyoypos(&tmped);
				if(w3pos <= wed->mypos)
				{	/* end line */
					wed->mxypos = w4mxypos;  /* recover */
					wed->sx = SCRMJIMAXm1;
					break;
				}

				wed->mypos = zigyoypos(wed);
				wed->mxypos = wed->mypos;
				wed->sx = 0;
				if((wed->sy) < SCRGYOMAXm1)
				{
					wed->sy++;
				}
				else
				{
					tmped.mypos = wed->oypos;
					w2int = zigyoypos(&tmped);
					wed->oypos = w2int;
					wed->scexec = SC_SAIGOADD; /* saisyu gyo add */
				}
			}
			else
			{
				/* */
			}
			break;

		case CR_KEY:  /* return key */
			/* enter(return) key */
			c = textmemcnt(wed);
			if( (c+2) > (wed->tsize-1) ) { break; }
			ret = mojioneins(wed,a); /* return -1 error */
			if( ret < 0 ) { break; }
			wed->mxypos++;
			ret = mojioneins(wed,LF_CODE); /*   */
			if( ret < 0 ) { break; }
			wed->mxypos++;
			wed->mypos = wed->mxypos;
			wed->bsx = wed->sx; /* backup */
			wed->sx=0;
			wed->tlinecnt++; /* text total line cnt */
			if((wed->sy) >= SCRGYOMAXm1)
			{
				tmped.mypos = wed->oypos;
				w2int = zigyoypos(&tmped);
				wed->oypos = w2int;
			}
			else
			{
				wed->bsy = wed->sy; /* backup */
				wed->sy++;
			}
			wed->scexec = SC_SYINS;
			break;

		case BS_KEY: /* backspace key */
			wed -> scexec = SC_CMIGISAI;
			if(wed->mxypos >= 1)
			{
				w3pos = zengyoypos(wed);
				tmped.mypos = w3pos;
				c = getgyolen(&tmped);
				wed->mxypos--;
				wed->sx--;
				w1char = wed->tmem[(wed->mxypos)];
				if(w1char == TAB_KEY)
				{
					wed->sx = gettabscx(wed);
					if(wed->sx > SCRMJIMAXm1)
					{
						wed->sx = SCRMJIMAXm1;
					}
					mojigyodel(wed);
				}
				else
				{
					if(w1char == LF_CODE)
					{
						if(wed->mxypos >= 1)
						{
							if(wed->tmem[(wed->mxypos-1)] == CR_CODE)
							{
								mojigyodel(wed);
								wed->mxypos--;
								w1char = CR_CODE;
							}
						wed -> scexec = SC_SYDEL;
						}
					}
					if(w1char == CR_CODE)
					{
						wed -> scexec = SC_SYDEL;
						mojigyodel(wed);
						wed->mypos = w3pos;
						wed->mxypos = w3pos;
						w2int = wed->mxypos;

						wed->mxypos = w2int+c; /* adj */
						adjtabmxypos(wed);  /* sx -> mxypos adj */
						adjtabscx(wed);     /* mxypos -> sx adj */

						wed->tlinecnt--;  /* text total line cnt */
						if(wed->sy >= 1)
						{
							wed->sy--;
						}
						else
						{
							wed->oypos = w3pos;
							wed -> scexec = SC_SYDAKE;
						}
					}
				}
				if(w1char >= SPC_CODE)
				{
					w2int = chksjismx(wed);
					mojigyodel(wed);
					if( w2int == 0)
					{
						/* no error */
					}
					else
					{
						/* shift jis */
						if(wed->mxypos >= 1)
						{
							wed->mxypos--;
							wed->sx--;
							mojigyodel(wed); /* sarani del */
						}
					}
					
				}
			}
			break;

		case EDSCDEL: /* del key */
			wed->scexec = SC_CMIGISAI;
			w1char = wed->tmem[wed->mxypos];

			if(w1char == CR_CODE)
			{
				mojigyodel(wed);
				w1char = wed->tmem[wed->mxypos];
				if(w1char == LF_CODE)
				{
					mojigyodel(wed);
				}
				wed->scexec = SC_SYDEL;
				wed->tlinecnt--;  /* text total line count */
			}
			else
			{
				/* other */
				if(w1char >= 1)
				{
					mojigyodel(wed);
					if( chksjis1b(w1char) != 0)
					{
						/* shift jis , sarani 1 del */
						mojigyodel(wed);
					}
				}
			}
			w5sx = gettabscx(wed);
			if( w5sx > SCRMJIMAXm1)
			{
				w5sx = SCRMJIMAXm1;
			}
			wed->sx = w5sx;
			break;

		case TAB_KEY:   /* tab key */
			wed->scexec = SC_CMIGISAIND;
			w5sx = gettabscx(&tmped);
			if( w5sx > SCRMJIMAXm1)
			{
				break;
			}

			ret = mojioneins(wed,a); /* return -1 error */
			if( ret == 0)
			{
				wed->mxypos++;
				wed->sx = gettabscx(wed);
				if( wed->sx > SCRMJIMAXm1)
				{
					wed->sx = SCRMJIMAXm1;
				}
			}
			else /* ret -1 */
			{
				/* none */
			}
			break;

		case 0:
			/* nanimo sinai */
		break;

		default:   /* other key */
			wed -> scexec = SC_CMIGISAIND;
			/* moji 1 insert */

			if( wed->sx > SCRMJIMAXm1)
			{
				if( f_sjis1b == 0 ) { retmojisyori=-1; break;}
				else
				{
					retmojisyori=-1;
					/* maeno code mukouka */
					w3pos = wed->mxypos;
					if(w3pos >= 1)
					{
						w3pos--;
						w1char = wed->tmem[w3pos];
						if(chksjis1b(w1char) != 0)
						{
							/* shift jis 1 mojime mukou ka */
							wed->tmem[w3pos] = SPC_CODE;
						}
					}
					f_sjis1b =0;
					break;
				}
			}

			if( f_sjis1b != 0 )
			{
				f_sjis1b = 0; /* clear */
			}
			else
			{	/* ==0 */
				if( chksjis1b(a) != 0)
				{
					f_sjis1b = 1;
				}
			}

			ret = mojioneins(wed,a); /* return -1 error */

			if( ret == 0)
			{
				/* no error */
				wed->sx = gettabscx(wed);
				if(wed->sx > SCRMJIMAXm1)
				{
					wed->sx = SCRMJIMAXm1;
				}
				else
				{
					wed->mxypos++;
					wed->sx++;
				}
			}
			else  /* ret == -1 */
			{
				/* error */
				/* shift jis taisaku */
				if(f_sjis1b != 0)
				{
					w3pos = wed->mxypos;
					if(w3pos >= 1)
					{
						w3pos--;
						w1char = wed->tmem[w3pos];
						if(chksjis1b(w1char) != 0)
						{
							/* shift jis 1 mojime mukou ka */
							wed->tmem[w3pos] = SPC_CODE;
						}
					}
				}
			}
	}
	return retmojisyori;
}
