/* main define */
/* edmi - text editor min - */
/* (c)2024 wnc develop / t.w. */
/* The MIT License */
/* org20240529 */
/* rev20240628 EDSCDEL add */
/* rev20240701 CTRL_C CTRL_Q add */
/* rev20240715 edit_dat SCRMJIMAX SCRGYOMAX add */
/* rev20240725 DEBUG add ,TEXTMEMSIZ move(<-main.c) */
/* rev20240725 SCRMJIMAXm1 , SCRGYOMAXm1 move(<-mainact.cpp) */
/* rev20240801 OUTCA,CURSORX option */
/* rev20240916 help,mes { */
/* rev20241004 copygyou,harituke */
/* rev20241005 rollup,rolldown code move */

#ifndef MAINDEF_H
#define MAINDEF_H

/* debug mode  ==1 on,==0 off */
#define DEBUG 0

/* version */ /* ed11 20241005 */
#define HELP00 "edmi v0.11 (c)2024 wnc develop\n"
#define HELP01 "(text editor min PC-9801)\n\n"
#define HELP02 "edmi [-4] [-r] [filename]\n\n"
#define HELP03 "-4   TAB4 (w8)\n"
#define HELP04 "-r   ǍpN\n\n"
#define HELP05 "-- L[ --\n"
#define HELP06 "Ctrl+C 1s , Ctrl+V 1s\t\nCtrl+K 1s폜\n"
#define HELP07 "Ctrl+E Otĕۑ , Ctrl+S ㏑ۑ\n"
#define HELP08 "Ctrl+Q I(ۑȂ)\n"

/* message */ /* ed10 */
#define MES000 "ۑ̧ٖ:"
#define MES001 "### ذ(Ǎp)ǂꂩ  Ă ###"

/* ed6 20240801 */
/* ==1 use */
#define OUTCA 1   /* outca use (int29h) */
#define CURSORX 1 /* cursorx use (io.sys direct) */

/* screen kakikae meirei */
#define SC_ALL 0         /* gamen zenbu koushin */
#define SC_SYDAKE 1      /* gamen sy gyo nomi kakikae */
#define SC_SENTOADD 2    /* gamen sentogyoe kuuhaku add */
#define SC_SAIGOADD 3    /* gamen saisyugyo kuuhaku add */
#define SC_CMIGISAI 4    /* gamen cur migi sai kakikae */
#define SC_CMIGISAIND 5  /* gamen cur migi sai kakikae no del */
#define SC_CMIGILAST 6   /* gamen cur migi lastline kakikae */
#define SC_SYINS 7       /* gamen sy insert line and kakikae */
#define SC_SYDEL 8       /* gamen sy delete line and kakikae */
#define SC_SONOMAMA 255  /* gamen kakikae nai */
#define SC_DELTRUE 0     /* kakikae mae syoukyo suru */
#define SC_DELFALSE -1   /* kakikae mae syoukyo sinai */

/* int dc pc-9801 */
#define EDSCUP    0x1e
#define EDSCDOWN  0x1f
#define EDSCLEFT  0x1d
#define EDSCRIGHT 0x1c
#define EDSCDEL   0x7f
/*#define EDSCRUP   0x0f*/   /* roll up */
/*#define EDSCRDN   0x10*/   /* roll down */
#define EDSCRUP   0x19   /* roll up (ed11)*/
#define EDSCRDN   0x14   /* roll down (ed11) */

/* ctrl + key */
#define CTRL_A 0x01   /* */
#define CTRL_B 0x02   /* */
#define CTRL_C 0x03   /* copy */
#define CTRL_D 0x04
#define CTRL_E 0x05   /* namae wo tukete hozon */
#define CTRL_F 0x06
#define CTRL_G 0x07
#define CTRL_H 0x08   /* (BS key) */
#define CTRL_I 0x09   /* (TAB key) */
#define CTRL_J 0x0a   /* (LF code) */
#define CTRL_K 0x0b   /* gyo sakujyo */
#define CTRL_L 0x0c
#define CTRL_M 0x0d   /* (CR code) */
#define CTRL_N 0x0e
#define CTRL_O 0x0f
#define CTRL_P 0x10
#define CTRL_Q 0x11   /* software exit */
#define CTRL_R 0x12
#define CTRL_S 0x13   /* uwagaki hozon */
#define CTRL_T 0x14   /* roll down */
#define CTRL_U 0x15
#define CTRL_V 0x16   /* haritsuke */
#define CTRL_W 0x17
#define CTRL_X 0x18
#define CTRL_Y 0x19   /* roll up */
#define CTRL_Z 0x1a   /* (EOF code) */

/* key and code */
#define BS_KEY 0x08
#define BS_CODE BS_KEY
#define TAB_KEY 0x09
#define TAB_CODE TAB_KEY
#define CR_KEY 0x0d
#define CR_CODE CR_KEY
#define LF_CODE 0x0a
#define ESC_KEY 0x1b
#define ESC_CODE ESC_KEY
#define SPC_KEY 0x20
#define SPC_CODE SPC_KEY
#define EOF_CODE 0x1a

/* editor control */
typedef struct{
	char *tmem;  /* text memory */
	int tsize;   /* text memory size */
	int tusize;  /* text use memory size */
	int mypos;  /* memory y position */
	int mxypos; /* memory y position + x */
	int oypos;  /* screen output start y position */
	int sx;  /* screen x */
	int sy;  /* screen y */
	int bsx; /* screen back up sx */
	int bsy; /* screen back up sy */
	int scexec;   /* screen output execode ED5 */
	int tlinecnt; /* text total line count */
	int tab;      /* screen tab size */
}edit_dat;

/* screen 20240715 */
#if DEBUG == 0
#define SCRGYOMAX 24
#define SCRMJIMAX 79
#elif DEBUG == 1
#define SCRGYOMAX 10
#define SCRMJIMAX 20
#endif

/* tab size */
#define TAB8SIZ 8
#define TAB4SIZ 4

/* memory 20240723 */
#if DEBUG == 0
#define TEXTMEMSIZ 30000
#elif DEBUG == 1
#define TEXTMEMSIZ 200
#endif

/* ed5 20240725 */
#define SCRMJIMAXm1 (SCRMJIMAX-1)
#define SCRGYOMAXm1 (SCRGYOMAX-1)

/* gyocntzan mode */
#define GCZ_DEF 0     /* nokori zengyo cnt */
#define GCZ_SCYMAX 1  /* limit screen y max */

#endif  /* MAINDEF_H */

